#from opencv.cv import *
#from opencv.highgui import *

from motion import *
import math
import random
import msvcrt
import serial

MINTURNSPEED = 0.5
MINGOSPEED = 1.0

lastdatax = 0
lastdatay = 0

def dir(i):
    if i > 0:
        return 0.5
    elif i < 0:
        return -0.5
    else:
        return 0

def wander(lastdatax, lastdatay):
    try:
        prevturn = prevturn
    except:
        prevturn = 0
    goval = random.uniform(0,7) + 2*lastdatay
    try:
        Go(goval)
    except:
        print goval
        return
    turnval = random.uniform(-5,5) + 2*lastdatax + dir(prevturn)
    prevturn = turnval
    try:
        Turn(turnval, RIGHT)
    except:
        print turnval

def takePicture():
    ser.write("1")

#initialize the files to read camera information from
file = open("input.txt", "w")
file.write(" ")
file.close()
file = open("input2.txt", "w")
file.write(" ")
file.close()

#initialize the robotic picture-taking finger
ser = serial.Serial()
ser.port = 4
ser.baudrate = 9600
ser.timeout = 0
ser.open()

InitializeRobot(4)

quit = False

while(not quit):
#    char = msvcrt.getch()
#    if char == chr(27):
#	quit = True
#	continue
    try:
        file = open("input2.txt", "r")
        x = float(file.readline())
        y = float(file.readline())
        lastdatax = x
        lastdatay = y
        file.close()
        if(abs(x) > 0.01):
            if (math.sin(x) < 0):
	        Turn(min(-MINTURNSPEED,5*math.sin(x)), RIGHT)
	    else:
	        Turn(max(MINTURNSPEED,5*math.sin(x)), RIGHT)
            Go(0)
        elif abs(y) > 0.1:
            Turn(0, RIGHT)
            if (y < 0):
	        Go(min(-MINGOSPEED,5*y), RIGHT)
	    else:
	        Go(max(MINGOSPEED,5*y), RIGHT)
        else:
            print "got it!"
            takePicture()
            lastdatax = 0
            lastdatay = 0
            TurnAngle(3.14159, RIGHT)
            file = open("input.txt", "w")
            file.write(" ")
            file.close()
            file = open("input2.txt", "w")
            file.write(" ")
            file.close()
	    quit = True
    except:
        try:
            file = open("input.txt", "r")
            x = float(file.readline())
            y = float(file.readline())
            lastdatax = x
            lastdatay = y+3
            file.close()
            if(abs(x) > 0.01):
                if (math.sin(x) < 0):
	            Turn(min(-MINTURNSPEED,5*math.sin(x)), RIGHT)
	        else:
    	            Turn(max(MINTURNSPEED,5*math.sin(x)), RIGHT)
                Go(0)
            else:
                Turn(0, RIGHT)
                Go(3*y+4)
        except:
            wander(lastdatax, lastdatay)
            lastdatax = lastdatax * (1-0.05)
            lastdatay = lastdatay * (1-0.05)
    file.close()



CloseRobot()

